// TestMenuBitmapsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestMenuBitmaps.h"
#include "TestMenuBitmapsDlg.h"


#ifdef _DEBUG
//#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTestMenuBitmapsDlg dialog




CTestMenuBitmapsDlg::CTestMenuBitmapsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestMenuBitmapsDlg::IDD, pParent)
{
	GdiplusStartupInput gdiplusStartupInput;
	GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);


	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	//See what version of Windows we're running on
	OSVERSIONINFO osi;
	osi.dwOSVersionInfoSize = sizeof(osi);
	BOOL bGV = GetVersionEx(&osi);
	ASSERT(bGV);

	//Check for "special" OS
	bWinXP_Only = bGV && (osi.dwMajorVersion == 5 && osi.dwMinorVersion >= 1);


	hUxTheme = LoadLibrary(_T("UxTheme.dll"));
	if(hUxTheme)
	{
		(FARPROC&)pfnGetBufferedPaintBits = GetProcAddress(hUxTheme, "GetBufferedPaintBits");
		(FARPROC&)pfnBeginBufferedPaint = GetProcAddress(hUxTheme, "BeginBufferedPaint");
		(FARPROC&)pfnEndBufferedPaint = GetProcAddress(hUxTheme, "EndBufferedPaint");
	}
	else
	{
		pfnGetBufferedPaintBits = NULL;
		pfnBeginBufferedPaint = NULL;
		pfnEndBufferedPaint = NULL;
	}
}

void CTestMenuBitmapsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATIC_PIC1, stPic1);
}

BEGIN_MESSAGE_MAP(CTestMenuBitmapsDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_SHOWMENU, &CTestMenuBitmapsDlg::OnBnClickedButtonShowmenu)
	ON_BN_CLICKED(IDC_BUTTON_SHOW_MENU2, &CTestMenuBitmapsDlg::OnBnClickedButtonShowMenu2)
END_MESSAGE_MAP()


// CTestMenuBitmapsDlg message handlers

BOOL CTestMenuBitmapsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	HICON hIcon = LoadIconSmart(IDI_ICON_TEST1, 24, 24);
	HBITMAP hBmp = CreatePARGBBitmapFromIcon2(hIcon);

	stPic1.SetBitmap(hBmp);

	//INFO: At this point I don't care about deleting 'hIcon' and 'hBmp'
	//      They will be removed when this test app closes...

	return TRUE;  // return TRUE  unless you set the focus to a control
}

HICON CTestMenuBitmapsDlg::LoadIconSmart(UINT nResIconID, int nCx, int nCy)
{
	//Loads an icon by trying to scale it down
	//'nCx' = requested width of the resulting icon in pixels
	//'nCy' = requested height of the resulting icon in pixels
	//RETURN:
	//		= Icon handle, must be removed with a call to DestroyIcon()
	//		= NULL if error
	HICON hIcon = NULL;

	HRESULT (WINAPI *pfnLoadIconWithScaleDown)(HINSTANCE, PCWSTR, int, int, HICON *) = NULL;

	HMODULE hComCtrl32 = LoadLibrary(_T("Comctl32.dll"));
	if(hComCtrl32)
	{
		(FARPROC&)pfnLoadIconWithScaleDown = GetProcAddress(hComCtrl32, "LoadIconWithScaleDown");
	}

	//Do we have a newer API
	if(pfnLoadIconWithScaleDown)
	{
		//Use newer method
		pfnLoadIconWithScaleDown(theApp.m_hInstance, MAKEINTRESOURCE(nResIconID), nCx, nCy, &hIcon);
	}
	else
	{
		//Use old API that scales it up that distorts the icon
		hIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(nResIconID), IMAGE_ICON, nCx, nCy, 0);
	}

	return hIcon;
}


void CTestMenuBitmapsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestMenuBitmapsDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestMenuBitmapsDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

Bitmap* CTestMenuBitmapsDlg::LoadGDIPlusImageFromResource(UINT nResID, LPCTSTR pResType)
{
	//Load a GDI plus image from a resource
	//'nResID' = Resource ID
	//'pResType' = Resource type (see FindResource() for types)
	//RETURN:
	//		= Image pointer if loaded OK, (must be removed with delete!)
	//		= NULL if error
	Bitmap* pImage = NULL;

	HMODULE hModule = ::GetModuleHandle(NULL);
	HRSRC hRes = ::FindResource(hModule, MAKEINTRESOURCE(nResID), pResType);
	if(hRes)
	{
		long szLength = ::SizeofResource(hModule, hRes);
		HGLOBAL hGlobal = ::LoadResource(hModule, hRes);
		if(szLength && hGlobal)
		{
			//Get resource data & size
			LPVOID pData = LockResource(hGlobal);
			DWORD dwSz = SizeofResource(hModule, hRes);
			if(pData && dwSz)
			{
				//Create a global memory object with it
				HGLOBAL hMem = GlobalAlloc(GMEM_MOVEABLE, dwSz);
				LPVOID pImageData = ::GlobalLock(hMem);
				if(pImageData)
				{
					//Copy data
					memcpy(pImageData, pData, dwSz);

					//Create stream (with auto-release)
					IStream* pStream = NULL;
					if(::CreateStreamOnHGlobal(hMem, TRUE, &pStream) == S_OK)
					{
						//Now load image from stream
						//pImage = Image::FromStream(pStream);
						pImage = Bitmap::FromStream(pStream);

						//Check the result
						if(pImage)
						{
							//Check status
							Status s = pImage->GetLastStatus();
							if(s != Ok)
							{
								//Error
								delete pImage;
								pImage = NULL;
							}
						}

						//Release mem
						pStream->Release();
					}

					::GlobalUnlock(hMem);
				}

				//Free mem <-- Can't do it here!!! It will be auto released
				//if(hMem)
				//	GlobalFree(hMem);
			}
		}
	}

	return pImage;
}

Bitmap* CTestMenuBitmapsDlg::LoadGDIPlusImageFromIconResource(UINT nResID)
{
	//Load a GDI plus image from an Icon resource
	//'nResID' = Resource ID
	//RETURN:
	//		= Image pointer if loaded OK, (must be removed with delete!)
	//		= NULL if error
	Bitmap* pImage = NULL;


	#pragma pack( push )
	#pragma pack( 2 )
	typedef struct
	{
	   BYTE   bWidth;               // Width, in pixels, of the image
	   BYTE   bHeight;              // Height, in pixels, of the image
	   BYTE   bColorCount;          // Number of colors in image (0 if >=8bpp)
	   BYTE   bReserved;            // Reserved
	   WORD   wPlanes;              // Color Planes
	   WORD   wBitCount;            // Bits per pixel
	   DWORD   dwBytesInRes;         // how many bytes in this resource?
	   WORD   nID;                  // the ID
	} GRPICONDIRENTRY, *LPGRPICONDIRENTRY;
	#pragma pack( pop )

	// #pragmas are used here to insure that the structure's
	// packing in memory matches the packing of the EXE or DLL.
	#pragma pack( push )
	#pragma pack( 2 )
	typedef struct 
	{
	   WORD            idReserved;   // Reserved (must be 0)
	   WORD            idType;       // Resource type (1 for icons)
	   WORD            idCount;      // How many images?
	   GRPICONDIRENTRY   idEntries[1]; // The entries for each image
	} GRPICONDIR, *LPGRPICONDIR;
	#pragma pack( pop )

	//// Load the DLL/EXE without executing its code
	//hLib = LoadLibraryEx( szFileName, NULL, LOAD_LIBRARY_AS_DATAFILE );
	//// Find the group resource which lists its images
	//hRsrc = FindResource( hLib, MAKEINTRESOURCE( nId ), RT_GROUP_ICON );
	//// Load and Lock to get a pointer to a GRPICONDIR
	//hGlobal = LoadResource( hLib, hRsrc );
	//lpGrpIconDir = LockResource( hGlobal );
	//// Using an ID from the group, Find, Load and Lock the RT_ICON
	//hRsrc = FindResource( hLib, MAKEINTRESOURCE( lpGrpIconDir->idEntries[0].nID ),
	//					  RT_ICON );
	//hGlobal = LoadResource( hLib, hRsrc );
	//lpIconImage = LockResource( hGlobal );
	//// Here, lpIconImage points to an ICONIMAGE structure

	HMODULE hModule = ::GetModuleHandle(NULL);
	HRSRC hResDir = ::FindResource(hModule, MAKEINTRESOURCE(nResID), RT_GROUP_ICON);
	if(hResDir)
	{
		// Load and Lock to get a pointer to a GRPICONDIR
		HGLOBAL hGlobalDir = ::LoadResource(hModule, hResDir);
		GRPICONDIR* lpGrpIconDir = (GRPICONDIR*)LockResource(hGlobalDir);
		if(lpGrpIconDir)
		{
			int e = lpGrpIconDir->idCount;
			int f = lpGrpIconDir->idType;

			int nIIDRes = LookupIconIdFromDirectoryEx((PBYTE)lpGrpIconDir, TRUE, 24, 24, LR_DEFAULTCOLOR);
			HRSRC hRes = ::FindResource(hModule, MAKEINTRESOURCE(nIIDRes), RT_ICON);
			if(hRes)
			{
				long szLength = ::SizeofResource(hModule, hRes);
				HGLOBAL hGlobal = ::LoadResource(hModule, hRes);
				if(szLength && hGlobal)
				{
					//Get resource data & size
					LPVOID pData = LockResource(hGlobal);
					DWORD dwSz = SizeofResource(hModule, hRes);
					if(pData && dwSz)
					{
						//Create a global memory object with it
						HGLOBAL hMem = GlobalAlloc(GMEM_MOVEABLE, dwSz);
						LPVOID pImageData = ::GlobalLock(hMem);
						if(pImageData)
						{
							//Copy data
							memcpy(pImageData, pData, dwSz);

							//Create stream (with auto-release)
							IStream* pStream = NULL;
							if(::CreateStreamOnHGlobal(hMem, TRUE, &pStream) == S_OK)
							{
								//Now load image from stream
								//pImage = Image::FromStream(pStream);
								pImage = Bitmap::FromStream(pStream);

								//Check the result
								if(pImage)
								{
									//Check status
									Status s = pImage->GetLastStatus();
									if(s != Ok)
									{
										//Error
										delete pImage;
										pImage = NULL;
									}
								}

								//Release mem
								pStream->Release();
							}

							::GlobalUnlock(hMem);
						}

						//Free mem <-- Can't do it here!!! It will be auto released
						//if(hMem)
						//	GlobalFree(hMem);
					}
				}
			}


		}
	}

	return pImage;
}

HBITMAP CTestMenuBitmapsDlg::CreatePARGBBitmapFromIcon2(HICON hIcon)
{
	//Make a PARGB bitmap from 'hIcon' icon (using GDI+)
	//RETURN:
	//		= Bitmap handle (must be removed with DeleteObject)
	//		= NULL if error
	HBITMAP hResBmp = NULL;

	//Bitmap* pImg = LoadGDIPlusImageFromIconResource(IDI_ICON_TEST1);
	//if(pImg)
	//{
	//	HBITMAP hbmp = 0;

	//	if(pImg->GetHBITMAP(Color::Color(0, 0, 0, 0), &hbmp) == Ok)
	//	{
	//		int r = 0;
	//	}

	//	delete pImg;
	//}

	Bitmap* pBmp = LoadGDIPlusImageFromResource(IDB_PNG1,  _T("PNG"));

	if(pBmp)
	{
		if(pBmp->GetHBITMAP(Color::Color(0, 0, 0, 0), &hResBmp) == Ok)
		{
		}

		delete pBmp;
	}


	//if(hResBmp)
	//{
	//	//Get DC for reference
	//	HDC hDC = ::GetDC(NULL);
	//	if(hDC)
	//	{
	//		BITMAP bmColor = {0};
	//		if(::GetObject(hResBmp, sizeof(bmColor), &bmColor))
	//		{
	//			//Get color pixels
	//			BITMAPINFO bmiColor = {0};
	//			bmiColor.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	//			bmiColor.bmiHeader.biWidth = bmColor.bmWidth;
	//			bmiColor.bmiHeader.biHeight = -bmColor.bmHeight;
	//			bmiColor.bmiHeader.biPlanes = 1;
	//			bmiColor.bmiHeader.biBitCount = 32;
	//			bmiColor.bmiHeader.biCompression = BI_RGB;

	//			//Reserve mem
	//			DWORD dwBmpColorSize = ((bmColor.bmWidth * bmiColor.bmiHeader.biBitCount + 31) / 32) * bmColor.bmHeight;
	//			DWORD *pvBitsColor = new (std::nothrow) DWORD[dwBmpColorSize];
	//			if(pvBitsColor)
	//			{
	//				//Get color bits
	//				if(::GetDIBits(hDC, hResBmp, 0, bmColor.bmHeight, pvBitsColor, &bmiColor, DIB_RGB_COLORS))
	//				{

	//					//Create resulting bitmap as DIB
	//					BITMAPINFO bmi = {0};
	//					bmi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	//					bmi.bmiHeader.biWidth = bmColor.bmWidth;
	//					bmi.bmiHeader.biHeight = -bmColor.bmHeight;
	//					bmi.bmiHeader.biPlanes = 1;
	//					bmi.bmiHeader.biBitCount = 32;
	//					bmi.bmiHeader.biCompression = BI_RGB;

	//					BOOL bResBmp = FALSE;

	//					//Create a DIB section
	//					DWORD *pvBits = NULL;
	//					HBITMAP hResBmp2 = CreateDIBSection(hDC, &bmi, DIB_RGB_COLORS, (void**)&pvBits, NULL, 0);
	//					if(hResBmp2)
	//					{
	//						if(pvBits)
	//						{
	//							//Go through pixels
	//							//CString str;
	//							int i = 0;
	//							for(int y = 0; y < bmColor.bmHeight; y++)
	//							{
	//								for(int x = 0; x < bmColor.bmWidth; x++)
	//								{
	//									DWORD dw = pvBitsColor[i];
	//									pvBits[i] = dw;

	//									//str.AppendFormat(_T("%08X "), dw);

	//									i++;
	//								}

	//								//str += _T("\r\n");
	//								//TRACE(str);
	//								//str.Empty();
	//							}


	//							//Replace bitmaps
	//							::DeleteObject(hResBmp);
	//							hResBmp = hResBmp2;

	//						}
	//					}


	//				}
	//			}

	//			//Free mem
	//			if(pvBitsColor)
	//				delete[] pvBitsColor;
	//		}
	//	}


	//	//Release DC
	//	VERIFY(::ReleaseDC(NULL, hDC));
	//}


	return hResBmp;
}

HBITMAP CTestMenuBitmapsDlg::CreatePARGBBitmapFromIcon(HICON hIcon)
{
	//Make a PARGB bitmap from 'hIcon' icon
	//RETURN:
	//		= Bitmap handle (must be removed with DeleteObject)
	//		= NULL if error
	HBITMAP hResBmp = NULL;

	//Get DC for reference
	HDC hDC = ::GetDC(NULL);
	if(hDC)
	{
		//Get icon info
		ICONINFO ii = {0};
		if(::GetIconInfo(hIcon, &ii) &&
			ii.hbmColor &&
			ii.hbmMask)
		{
			BITMAP bmColor = {0};
			BITMAP bmMask = {0};
			if(::GetObject(ii.hbmMask, sizeof(bmMask), &bmMask) &&
				::GetObject(ii.hbmColor, sizeof(bmColor), &bmColor) &&
				bmMask.bmWidth == bmColor.bmWidth &&
				bmMask.bmHeight == bmColor.bmHeight)
			{
				//Get color pixels
				BITMAPINFO bmiColor = {0};
				bmiColor.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
				bmiColor.bmiHeader.biWidth = bmColor.bmWidth;
				bmiColor.bmiHeader.biHeight = -bmColor.bmHeight;
				bmiColor.bmiHeader.biPlanes = 1;
				bmiColor.bmiHeader.biBitCount = 32;
				bmiColor.bmiHeader.biCompression = BI_RGB;

				//Reserve mem
				DWORD dwBmpColorSize = ((bmColor.bmWidth * bmiColor.bmiHeader.biBitCount + 31) / 32) * bmColor.bmHeight;
				DWORD *pvBitsColor = new (std::nothrow) DWORD[dwBmpColorSize];
				if(pvBitsColor)
				{
					//Get color bits
					if(::GetDIBits(hDC, ii.hbmColor, 0, bmColor.bmHeight, pvBitsColor, &bmiColor, DIB_RGB_COLORS))
					{

						//Get mask pixels
						BITMAPINFO bmiMask = {0};
						bmiMask.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
						bmiMask.bmiHeader.biWidth = bmMask.bmWidth;
						bmiMask.bmiHeader.biHeight = -bmMask.bmHeight;
						bmiMask.bmiHeader.biPlanes = 1;
						bmiMask.bmiHeader.biBitCount = 32;
						bmiMask.bmiHeader.biCompression = BI_RGB;

						//Reserve mem
						DWORD dwBmpMaskSize = ((bmMask.bmWidth * bmiMask.bmiHeader.biBitCount + 31) / 32) * bmMask.bmHeight;
						DWORD *pvBitsMask = new (std::nothrow) DWORD[dwBmpMaskSize];
						if(pvBitsMask)
						{
							//Get color bits
							if(::GetDIBits(hDC, ii.hbmMask, 0, bmMask.bmHeight, pvBitsMask, &bmiMask, DIB_RGB_COLORS))
							{

								//Create resulting bitmap as DIB
								BITMAPINFO bmi = {0};
								bmi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
								bmi.bmiHeader.biWidth = bmColor.bmWidth;
								bmi.bmiHeader.biHeight = -bmColor.bmHeight;
								bmi.bmiHeader.biPlanes = 1;
								bmi.bmiHeader.biBitCount = 32;
								bmi.bmiHeader.biCompression = BI_RGB;

								BOOL bResBmp = FALSE;

								//Create a DIB section
								DWORD *pvBits = NULL;
								hResBmp = CreateDIBSection(hDC, &bmi, DIB_RGB_COLORS, (void**)&pvBits, NULL, 0);
								if(hResBmp)
								{
									if(pvBits)
									{
										//Go through pixels
										int i = 0;
										for(int y = 0; y < bmColor.bmHeight; y++)
										{
											for(int x = 0; x < bmColor.bmWidth; x++)
											{
												DWORD dwPix = 0;
												DWORD dwPixColor = pvBitsColor[i];
												DWORD dwPixMask = pvBitsMask[i];

												if(!(dwPixMask & 0xFFFFFF))
												{
													dwPix = dwPixColor;
												}

												//        AARRGGBB
										//		dwPix = 0xFF0000FF;
												pvBits[i] = dwPix;

												i++;
											}
										}

										//Done
										bResBmp = TRUE;
									}
								}

								//Did we succeed?
								if(!bResBmp)
								{
									//Free bitmap
									::DeleteObject(hResBmp);
									hResBmp = NULL;
								}
							}


							//Free mem
							delete[] pvBitsMask;

						}

					}
				}

				//Free mem
				if(pvBitsColor)
					delete[] pvBitsColor;
			}
		}

		//Free resources
		if(ii.hbmColor)
			VERIFY(::DeleteObject(ii.hbmColor));
		if(ii.hbmMask)
			VERIFY(::DeleteObject(ii.hbmMask));

		//Release DC
		VERIFY(::ReleaseDC(NULL, hDC));
	}

	return hResBmp;
}


void CTestMenuBitmapsDlg::OnBnClickedButtonShowmenu()
{
	// TODO: Add your control notification handler code here

	HMENU hMMenu = LoadMenu(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_MENU1));
	HMENU hMenu = GetSubMenu(hMMenu, 0);

	if(hMenu)
	{
		//Get mouse position
		POINT pnt;
		if(!GetCursorPos(&pnt))
		{
			//If for some reason mouse position could not be identified :)
			pnt.x = 0;
			pnt.y = 0;
		}


		HICON hIcon1 = LoadIconSmart(IDI_ICON_TEST1, 24, 24);
		HBITMAP hBmp1 = CreatePARGBBitmapFromIcon2(hIcon1);


		CString strName = _T("Some very long menu item name...");


		MENUITEMINFO mii = {0};
		mii.cbSize = sizeof(mii);
		mii.fMask = MIIM_BITMAP;
		mii.hbmpItem = hBmp1;
//		mii.fMask |= MIIM_FTYPE | MIIM_STRING;
//		mii.fType = MFT_STRING;
//		mii.dwTypeData = strName.GetBuffer();

		SetMenuItemInfo(hMenu, ID_1_TESTITEM2, FALSE, &mii);

	//	VERIFY(::SetMenuItemBitmaps(hMenu, ID_1_TESTITEM2, MF_BYCOMMAND, hBmp1, hBmp1));


		//Show menu (ask to return results here)
		int nRes = TrackPopupMenu(hMenu, TPM_RIGHTALIGN | TPM_TOPALIGN |
			TPM_LEFTBUTTON | TPM_VERPOSANIMATION | TPM_HORNEGANIMATION | TPM_RETURNCMD,
			pnt.x, pnt.y, 0, this->GetSafeHwnd(), NULL);


		::DeleteObject(hBmp1);
		::DestroyIcon(hIcon1);
	}

	//Destroy menu
	if(hMMenu)
		VERIFY(DestroyMenu(hMMenu));
}


void CTestMenuBitmapsDlg::PostNcDestroy()
{
	// TODO: Add your specialized code here and/or call the base class

	GdiplusShutdown(gdiplusToken);

	if(hUxTheme)
		::FreeLibrary(hUxTheme);

	CDialog::PostNcDestroy();
}

void CTestMenuBitmapsDlg::OnBnClickedButtonShowMenu2()
{
	// TODO: Add your control notification handler code here

	HMENU hMMenu = LoadMenu(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_MENU1));
	HMENU hMenu = GetSubMenu(hMMenu, 0);

	if(hMenu)
	{
		//Get mouse position
		POINT pnt;
		if(!GetCursorPos(&pnt))
		{
			//If for some reason mouse position could not be identified :)
			pnt.x = 0;
			pnt.y = 0;
		}


		HBITMAP hBmp1 = NULL;
		CArray<MENU_ITEM_DATA> arrMenuIcons;
		
		MENUITEMINFO mii = {0};
		mii.cbSize = sizeof(mii);

		//OS specific
		if(!bWinXP_Only)
		{
			//You can effectively specify any icon size!!!
			hBmp1 = IconToBitmapPARGB32(IDI_ICON_TEST1, 32, 32);

			//CString strName = _T("Some very long menu item name...");


			mii.fMask = MIIM_BITMAP;
			mii.hbmpItem = hBmp1;
			//mii.fMask |= MIIM_FTYPE | MIIM_STRING;
			//mii.fType = MFT_STRING;
			//mii.dwTypeData = strName.GetBuffer();
		}
		else
		{
			//Windows XP only
			
			//Load icon
			MENU_ITEM_DATA mid;

			mid.dwMenuIconID = ID_1_TESTITEM2;
			mid.dwResIconID = IDI_ICON_TEST1;

			//Size of the icon
			mid.szIcon.cx = 32;
			mid.szIcon.cy = 32;

			//Load icon handle
			mid.hIcon = LoadIconSmart(mid.dwResIconID, mid.szIcon.cx, mid.szIcon.cy);

			int nIndex = arrMenuIcons.Add(mid);

			mii.hbmpItem = HBMMENU_CALLBACK;
			mii.fMask = MIIM_BITMAP | MIIM_DATA | MIIM_ID;
			mii.wID = mid.dwMenuIconID;
			mii.dwItemData = (ULONG_PTR)&arrMenuIcons.GetAt(nIndex);
		}


		SetMenuItemInfo(hMenu, ID_1_TESTITEM2, FALSE, &mii);

	//	VERIFY(::SetMenuItemBitmaps(hMenu, ID_1_TESTITEM2, MF_BYCOMMAND, hBmp1, hBmp1));


		//Show menu (ask to return results here)
		int nRes = TrackPopupMenu(hMenu, TPM_RIGHTALIGN | TPM_TOPALIGN |
			TPM_LEFTBUTTON | TPM_VERPOSANIMATION | TPM_HORNEGANIMATION | TPM_RETURNCMD,
			pnt.x, pnt.y, 0, this->GetSafeHwnd(), NULL);


		if(hBmp1)
			::DeleteObject(hBmp1);
	}

	//Destroy menu
	if(hMMenu)
		VERIFY(DestroyMenu(hMMenu));
}


void CTestMenuBitmapsDlg::InitBitmapInfo(__out_bcount(cbInfo) BITMAPINFO *pbmi, ULONG cbInfo, LONG cx, LONG cy, WORD bpp)
{
    ZeroMemory(pbmi, cbInfo);
    pbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    pbmi->bmiHeader.biPlanes = 1;
    pbmi->bmiHeader.biCompression = BI_RGB;

    pbmi->bmiHeader.biWidth = cx;
    pbmi->bmiHeader.biHeight = cy;
    pbmi->bmiHeader.biBitCount = bpp;
}

HRESULT CTestMenuBitmapsDlg::Create32BitHBITMAP(HDC hdc, const SIZE *psize, void **ppvBits, HBITMAP* phBmp)
{
    *phBmp = NULL;

    BITMAPINFO bmi;
    InitBitmapInfo(&bmi, sizeof(bmi), psize->cx, psize->cy, 32);

	HDC hdcUsed = hdc ? hdc : ::GetDC(NULL);
    if (hdcUsed)
    {
        *phBmp = CreateDIBSection(hdcUsed, &bmi, DIB_RGB_COLORS, ppvBits, NULL, 0);
        if (hdc != hdcUsed)
        {
			::ReleaseDC(NULL, hdcUsed);
        }
    }

    return (NULL == *phBmp) ? E_OUTOFMEMORY : S_OK;
}

bool CTestMenuBitmapsDlg::HasAlpha(ARGB *pargb, SIZE& sizImage, int cxRow)
{
    ULONG cxDelta = cxRow - sizImage.cx;
    for (ULONG y = sizImage.cy; y; --y)
    {
        for (ULONG x = sizImage.cx; x; --x)
        {
            if (*pargb++ & 0xFF000000)
            {
                return true;
            }
        }

        pargb += cxDelta;
    }

    return false;
}

HRESULT CTestMenuBitmapsDlg::ConvertToPARGB32(HDC hdc, ARGB *pargb, HBITMAP hbmp, SIZE& sizImage, int cxRow)
{
    BITMAPINFO bmi;
    InitBitmapInfo(&bmi, sizeof(bmi), sizImage.cx, sizImage.cy, 32);

    HRESULT hr = E_OUTOFMEMORY;
    HANDLE hHeap = GetProcessHeap();
    void *pvBits = HeapAlloc(hHeap, 0, bmi.bmiHeader.biWidth * 4 * bmi.bmiHeader.biHeight);
    if (pvBits)
    {
        hr = E_UNEXPECTED;
        if (GetDIBits(hdc, hbmp, 0, bmi.bmiHeader.biHeight, pvBits, &bmi, DIB_RGB_COLORS) == bmi.bmiHeader.biHeight)
        {
            ULONG cxDelta = cxRow - bmi.bmiHeader.biWidth;
            ARGB *pargbMask = static_cast<ARGB *>(pvBits);

            for (ULONG y = bmi.bmiHeader.biHeight; y; --y)
            {
                for (ULONG x = bmi.bmiHeader.biWidth; x; --x)
                {
                    if (*pargbMask++)
                    {
                        // transparent pixel
                        *pargb++ = 0;
                    }
                    else
                    {
                        // opaque pixel
                        *pargb++ |= 0xFF000000;
                    }
                }

                pargb += cxDelta;
            }

            hr = S_OK;
        }

        HeapFree(hHeap, 0, pvBits);
    }

    return hr;
}


HRESULT CTestMenuBitmapsDlg::ConvertBufferToPARGB32(HPAINTBUFFER hPaintBuffer, HDC hdc, HICON hicon, SIZE& sizIcon)
{
	HRESULT hr;
    RGBQUAD *prgbQuad;
    int cxRow;
	if(pfnGetBufferedPaintBits)
	{
		hr = pfnGetBufferedPaintBits(hPaintBuffer, &prgbQuad, &cxRow);
		if (SUCCEEDED(hr))
		{
			ARGB *pargb = reinterpret_cast<ARGB *>(prgbQuad);
			if (!HasAlpha(pargb, sizIcon, cxRow))
			{
				ICONINFO info;
				if (GetIconInfo(hicon, &info))
				{
					if (info.hbmMask)
					{
						hr = ConvertToPARGB32(hdc, pargb, info.hbmMask, sizIcon, cxRow);
					}

					if(info.hbmColor)
						VERIFY(DeleteObject(info.hbmColor));

					if(info.hbmMask)
						VERIFY(DeleteObject(info.hbmMask));
				}
			}
		}
	}
	else
	{
		hr = E_NOTIMPL;
	}

    return hr;
}

HBITMAP CTestMenuBitmapsDlg::IconToBitmapPARGB32(UINT nResIconID, int nIconCx, int nIconCy)
{
    HRESULT hr = E_OUTOFMEMORY;
    HBITMAP hBmp = NULL;

	if(pfnBeginBufferedPaint &&
		pfnEndBufferedPaint)
	{
		HICON hIcon = LoadIconSmart(nResIconID, nIconCx, nIconCy);
		if(hIcon)
		{
			SIZE sizIcon;
			sizIcon.cx = nIconCx;	//GetSystemMetrics(SM_CXSMICON);		//Fuck Windows limitations! We'll use our own icon size...
			sizIcon.cy = nIconCy;	//GetSystemMetrics(SM_CYSMICON);

			RECT rcIcon = {0, 0, nIconCx, nIconCy};

			HDC hdcDest = CreateCompatibleDC(NULL);
			if(hdcDest) 
			{
				hr = Create32BitHBITMAP(hdcDest, &sizIcon, NULL, &hBmp);
				if(SUCCEEDED(hr)) 
				{
					hr = E_FAIL;

					HBITMAP hbmpOld = (HBITMAP)SelectObject(hdcDest, hBmp);
					if(hbmpOld) 
					{
						BLENDFUNCTION bfAlpha = { AC_SRC_OVER, 0, 255, AC_SRC_ALPHA };
						BP_PAINTPARAMS paintParams = {0};
						paintParams.cbSize = sizeof(paintParams);
						paintParams.dwFlags = BPPF_ERASE;
						paintParams.pBlendFunction = &bfAlpha;

						HDC hdcBuffer;
						HPAINTBUFFER hPaintBuffer = pfnBeginBufferedPaint(hdcDest, &rcIcon, BPBF_DIB, &paintParams, &hdcBuffer);
						if(hPaintBuffer) 
						{
							if(DrawIconEx(hdcBuffer, 0, 0, hIcon, sizIcon.cx, sizIcon.cy, 0, NULL, DI_NORMAL)) 
							{
								// If icon did not have an alpha channel, we need to convert buffer to PARGB.
								hr = ConvertBufferToPARGB32(hPaintBuffer, hdcDest, hIcon, sizIcon);
							}

							// This will write the buffer contents to the destination bitmap.
							pfnEndBufferedPaint(hPaintBuffer, TRUE);
						}

						SelectObject(hdcDest, hbmpOld);
					}
				}

				VERIFY(DeleteDC(hdcDest));
			}

			VERIFY(DestroyIcon(hIcon));

			if(FAILED(hr)) 
			{
				if(hBmp)
				{
					VERIFY(DeleteObject(hBmp));
					hBmp = NULL;
				}
			}
		}
	}

    return hBmp;
}
LRESULT CTestMenuBitmapsDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	// TODO: Add your specialized code here and/or call the base class

	if(message == WM_MEASUREITEM)
	{
		//Only if menu
		if(wParam == 0)
		{
			MEASUREITEMSTRUCT* pMS = (MEASUREITEMSTRUCT*)lParam;
			if(pMS &&
				pMS->CtlType == ODT_MENU)
			{
				MENU_ITEM_DATA* pMID = (MENU_ITEM_DATA*)pMS->itemData;
				ASSERT(pMID);

				if(pMS->itemID == pMID->dwMenuIconID)
				{
					pMS->itemHeight = pMID->szIcon.cy;
					pMS->itemWidth = pMID->szIcon.cx;

					return TRUE;
				}
			}
		}
	}
	else if(message == WM_DRAWITEM)
	{
		//Only if menu
		DRAWITEMSTRUCT* pDS = (DRAWITEMSTRUCT*)lParam;
		if(pDS)
		{
			if(pDS->CtlType == ODT_MENU)
			{
				//Get our data
				MENU_ITEM_DATA* pMID = (MENU_ITEM_DATA*)pDS->itemData;
				ASSERT(pMID);

				if(pDS->itemID == pMID->dwMenuIconID)
				{
					//Load icon
					HICON hIcon = LoadIconSmart(pMID->dwResIconID, pMID->szIcon.cx, pMID->szIcon.cy);
					if(hIcon)
					{
						//Draw icon
						VERIFY(DrawIconEx(pDS->hDC,
							pDS->rcItem.left - GetSystemMetrics(SM_CXMENUCHECK) / 2,
							pDS->rcItem.top + (pDS->rcItem.bottom - pDS->rcItem.top - pMID->szIcon.cy) / 2,
							hIcon, 
							pMID->szIcon.cx,
							pMID->szIcon.cy,
							0, NULL, DI_NORMAL));

						VERIFY(::DestroyIcon(hIcon));

						return TRUE;
					}
				}
			}
		}
	}

	return CDialog::WindowProc(message, wParam, lParam);
}
