// TestMenuBitmapsDlg.h : header file
//

#pragma once
#include "afxwin.h"

#include <Gdiplus.h>
using namespace Gdiplus;
#pragma comment(lib, "gdiplus.lib")




struct MENU_ITEM_DATA{
	HICON hIcon;
	UINT dwResIconID;
	UINT dwMenuIconID;
	SIZE szIcon;

	MENU_ITEM_DATA()
	{
		hIcon = NULL;
		dwResIconID = 0;
		dwMenuIconID = 0;
		szIcon.cx = 0;
		szIcon.cy = 0;
	}
	~MENU_ITEM_DATA()
	{
		if(hIcon)
		{
			::DestroyIcon(hIcon);
			hIcon = NULL;
		}
	}
};


// CTestMenuBitmapsDlg dialog
class CTestMenuBitmapsDlg : public CDialog
{
// Construction
public:
	CTestMenuBitmapsDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_TESTMENUBITMAPS_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	static HICON LoadIconSmart(UINT nResIconID, int nCx, int nCy);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedButtonShowmenu();
	Bitmap* LoadGDIPlusImageFromResource(UINT nResID, LPCTSTR pResType);
	Bitmap* LoadGDIPlusImageFromIconResource(UINT nResID);
	HBITMAP CreatePARGBBitmapFromIcon2(HICON hIcon);
	HBITMAP CreatePARGBBitmapFromIcon(HICON hIcon);
	CStatic stPic1;
protected:
	ULONG_PTR           gdiplusToken;
	virtual void PostNcDestroy();
public:
	afx_msg void OnBnClickedButtonShowMenu2();
	void InitBitmapInfo(__out_bcount(cbInfo) BITMAPINFO *pbmi, ULONG cbInfo, LONG cx, LONG cy, WORD bpp);
	HRESULT Create32BitHBITMAP(HDC hdc, const SIZE *psize, void **ppvBits, HBITMAP* phBmp);
	bool HasAlpha(ARGB *pargb, SIZE& sizImage, int cxRow);
	HRESULT ConvertToPARGB32(HDC hdc, ARGB *pargb, HBITMAP hbmp, SIZE& sizImage, int cxRow);
	HRESULT ConvertBufferToPARGB32(HPAINTBUFFER hPaintBuffer, HDC hdc, HICON hicon, SIZE& sizIcon);
	HBITMAP IconToBitmapPARGB32(UINT nResIconID, int nIconCx, int nIconCy);

	BOOL bWinXP_Only;			//TRUE if the OS is Windows XP only (not later versions!)
	HMODULE hUxTheme;
	HRESULT (WINAPI *pfnGetBufferedPaintBits)(HPAINTBUFFER, RGBQUAD **, int*);
	HPAINTBUFFER (WINAPI *pfnBeginBufferedPaint)(HDC, const RECT *, BP_BUFFERFORMAT, BP_PAINTPARAMS *, HDC *);
	HRESULT (WINAPI *pfnEndBufferedPaint)(HPAINTBUFFER, BOOL);
protected:
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
};
